#include"P1.c"

int main()
{
  int Error_Flag = NO_ERRORS_DETECTED;
  int Event_Time = 8;
  int Number_Of_Servers = 0;
  Customer_Pointer Ptr_Customer = NULL;
  Event_Node_Pointer Ptr_Next_Event_List = NULL;
  Wait_Queue Wait_Queue [1] = {{0,0,NULL,NULL}};
  Server_State Server_Status [1] = {Available};
  Queue_Method Queue_Method = None;
  
  printf ("Testing function Handle_Arrived... \n");

  /* Set nodes */

  Ptr_Customer = (Customer_Pointer) malloc (sizeof
(Customer_Simulation_Data));
  if (Ptr_Customer == NULL)
  {
    Error_Flag = ERROR_DETECTED;
    return Error_Flag;
  }
  
  /*
   * Empty Event Queue, just pass in the NULL pointer Ptr_Next_Event_List
   */

  Ptr_Customer->Customer_Number = 1;
  Ptr_Customer->Time_Arrived = 0;
  Ptr_Customer->Time_Check_Out = 0;
  Ptr_Customer->Queue_Length = 0;
  Ptr_Customer->Items_In_Queue = 4;
  Ptr_Customer->Server = 0;
  Ptr_Customer->Time_Departed = 0;
  Ptr_Customer->Queue_Method = Single_Queue;
  Ptr_Customer->Parameters.Interarrival_Time = 3;
  Ptr_Customer->Parameters.Number_Of_Items_Purchased = 5;
  Ptr_Customer->Parameters.Shopping_Time = 20;
  Ptr_Customer->Parameters.Service_Time = 5;

  
  printf ("\n\n"); 
  printf ("Customer: %d T_Arrived: %d #_Purchased: %d\n",
             Ptr_Customer->Customer_Number,
             Ptr_Customer->Time_Arrived,
             Ptr_Customer->Parameters.Number_Of_Items_Purchased);
  printf ("Shopping Time: %d\n", Ptr_Customer->Parameters.Shopping_Time);
  printf ("\n\n");

  
  Handle_Arrived (Ptr_Customer,
                  Event_Time,
                  &Ptr_Next_Event_List);

  free (Ptr_Customer);
  free (Ptr_Next_Event_List);

  printf ("\n\nTesting function Handle_Checking_Out... \n");

  /* Set up Event time and number of servers */

  Event_Time = 25;
  Number_Of_Servers = 1;

  /* Set up Customer information */

  Ptr_Customer = (Customer_Pointer) malloc (sizeof
(Customer_Simulation_Data));
  if (Ptr_Customer == NULL)
  {
    Error_Flag = ERROR_DETECTED;
    return Error_Flag;
  }

  Ptr_Customer->Customer_Number = 2;
  Ptr_Customer->Time_Arrived = 8;
  Ptr_Customer->Time_Check_Out = 0;
  Ptr_Customer->Queue_Length = 0;
  Ptr_Customer->Items_In_Queue = 4;
  Ptr_Customer->Server = 0;
  Ptr_Customer->Time_Departed = 0;
  Ptr_Customer->Queue_Method = Single_Queue;
  Ptr_Customer->Parameters.Interarrival_Time = 5;
  Ptr_Customer->Parameters.Number_Of_Items_Purchased = 15;
  Ptr_Customer->Parameters.Shopping_Time = 10;
  Ptr_Customer->Parameters.Service_Time = 10;


  /* Set up Next Event List */

  Ptr_Next_Event_List = (Event_Node_Pointer) malloc (sizeof (Event_Node));

  if (Ptr_Next_Event_List == NULL)
  {
    Error_Flag = ERROR_DETECTED;
    return Error_Flag;
  }

  Ptr_Next_Event_List->Customer_Event_Time = 25;
  Ptr_Next_Event_List->Customer_Status = Checking_Out;
  Ptr_Next_Event_List->Ptr_Customer = Ptr_Customer;
  Ptr_Next_Event_List->Ptr_Next = NULL;

  printf ("\n\n");
  printf ("Event Time: %d\n", Event_Time);
  printf ("Customer: %d Server_Id: %d #_Purchased: %d\n",
             Ptr_Customer->Customer_Number,
             Ptr_Customer->Server,
             Ptr_Customer->Parameters.Number_Of_Items_Purchased);
  printf ("Customer Event Time: %d Check_Out_Time: %d\n", 
             Ptr_Next_Event_List->Customer_Event_Time,
             Ptr_Next_Event_List->Ptr_Customer->Time_Check_Out);
  printf ("\n\n");

  Handle_Checking_Out (
    Ptr_Customer,
    Event_Time,
    &Ptr_Next_Event_List,
    Wait_Queue,
    Queue_Method,
    Server_Status,
    Number_Of_Servers);

  printf ("\n\n");
  printf ("Customer: %d Server_Id: %d #_Purchased: %d\n",
             Ptr_Next_Event_List->Ptr_Customer->Customer_Number,
             Ptr_Next_Event_List->Ptr_Customer->Server,

Ptr_Next_Event_List->Ptr_Customer->Parameters.Number_Of_Items_Purchased);
  printf ("Shopping Time: %d Check_Out Time: %d\n", 
             Ptr_Next_Event_List->Ptr_Customer->Parameters.Shopping_Time,
             Ptr_Next_Event_List->Ptr_Customer->Time_Check_Out);
  printf ("\n\n");

  free (Ptr_Customer);
  free (Ptr_Next_Event_List);

  return Error_Flag;
} /* main */

