/* P2.h  -- Project 2 EE 368c Fall 2000 */

/*    $Author: ee368c $
 *      $Date: 2000/10/13 16:00:52 $
 *  $Revision: 1.2 $
 */

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <assert.h>

#define CALL_LIMIT ( 1000 )
#define MEMORY_LIMIT ( 50000 )
#define MAX_NODES ( 26 )
#define MAX_WEIGHT ( 99 )
#define NO_ERRORS_DETECTED ( 0 )
#define ERROR_DETECTED ( 1 )

typedef enum 
{
  False,
  True
} Boolean;

typedef enum 
{
  Forward,
  Backward
} Direction;

typedef int Matrix[MAX_NODES][MAX_NODES];

struct Node_Data
{
  char Name;
  Boolean Visited;
  int Forward_Sort_Order;
  int Backward_Sort_Order;
  int Earliest_Finish_Time;
  int Latest_Start_Time;
  Boolean Critical_Node;
};

typedef struct Node_Data Node_Data;

struct Node
{
  struct Arc
  {
    struct Node *Ptr_Node;
    int Arc_Value;
    struct Arc *Ptr_Next_Arc;
  };
  struct Node_Data Node_Info;
  struct Arc *Ptr_From_List;
  struct Arc *Ptr_To_List;
  struct Node *Ptr_Next_Node;
};

typedef struct Node NODE;
typedef NODE *Node_Pointer;

typedef struct Arc ARC;
typedef ARC *Arc_Pointer;


void Read_Adjacency_Matrix (
  Matrix Adjacency,
  int *Number_Of_Nodes);

void Print_Matrix (
  Matrix X,
  int Number_Of_Nodes);

void Build_Adjacency_Graph (
  Node_Pointer *Ptr_Graph,
  Matrix Adjacency,
  int Number_Of_Nodes);

void Delete_Adjacency_Graph (
  Node_Pointer *Ptr_Graph);

void Print_Weighted_Adjacency_Graph (
  Node_Pointer Ptr_Graph);

void Read_To_End_Of_Line (void);

void Read_Reply (int *Reply);

void Print_Pert_Summary (Node_Pointer Ptr_Graph);

int Pert (Node_Pointer Ptr_Graph);

void Check_Dynamic_Memory (void);

int Set_Limits (
  int Number_Of_Allowed_Calls,
  int Total_Dynamic_Memory_Allowed);

void *My_Malloc (size_t Number_Of_Bytes);

void *My_Calloc (
  size_t Number_Of_Items,
  size_t Number_Of_Bytes);

void My_Free (char *Pointer);


#define malloc( n )  My_Malloc((size_t)(n))
#define calloc( n, s ) My_Calloc((size_t)(n), (size_t)(s))
#define free( p )    My_Free((char *)(p))

