#include <stdio.h>

#define OK    0
#define ERROR 1

int print_error_data (int ch, int position)
   {
      int get_data (int *);
      int ch_save;
      int i;
      int p;

      ch_save = ch;

      while (    (ch != EOF)
              && (ch != '\n'))
            ch = get_data (&p);

      for (i = 1; i < position; i++)
         printf ("-");
      printf ("^\n");

      printf ("--- ERROR --- ");

      if ( ch_save == EOF)
            printf ("Symbol EOF  ");
         else
            if ( ch_save != '\n')
                   printf ("Symbol %3c  ", ch_save);
                else
                   printf ("symbol  \\n  ");

      printf ("position %2d\n", position);

      return ch;

   } /* print_error_data */


int get_data (int *position)
   {
      /*
       *  Reads a character from standard input
       *  and increments its position on the line
       */

      int ch;

      (*position)++;

      ch = getchar ();

      if (    (ch != '\n') && (ch != EOF) && (ch != '=') && (ch != '^')
           && (ch != '.')  && (ch != '~') && (ch != '(') && (ch != ')')
           && (ch != '*')  && (ch != 'a') && (ch != 'b') && (ch != 'c')
           && (ch != '0')  && (ch != '1') && (ch != '2') && (ch != '3')
           && (ch != '4')  && (ch != '5') && (ch != '6') && (ch != '7')
           && (ch != '8')  && (ch != '9') && (ch != 'x'))
         ch = '@';

      if (ch == EOF)
            putchar ('\n');
         else
            putchar (ch);

      return ch;

   } /* get_data */

int S (int *ch, int *position)
   {
      /*
       *  S ----->[E]-------->(=)-------->{end of line}
       */

      int E (int *ch, int *position);

      if ( E (&(*ch), &(*position)) == ERROR )
            return ERROR;
         else
            if (*ch == '=')
                  {
                     *ch = get_data (&(*position));
                     
                     if (*ch != '\n')
                           return ERROR;
                        else
                           return OK;
                  }
               else
                  return ERROR;
   } /* S */

int T (int *ch, int *position)
   {
      /*
       *       T --------------->[F]----------->
       *                   /              \
       *                  |                |
       *                  <------(*)<-------
       * 
       */

      int F (int *ch, int *position);

   } /* T */

int E (int *ch, int *position)
   {
      /*    
       *       E --------------->[T]----------->
       *                   /              \
       *                  |                |
       *                  <------(~)<-------
       */
      int T (int *ch, int *position);

   } /* E */

int F (int *ch, int *position)
   {
      /*
       *       F ---------->(^)----->[E]------------->
       *           |                             |
       *           --->(()----->[E]----->())----->
       *           |                             |
       *           -------->[V]----->(^)--------->
       */

      int E (int *ch, int *position);
      int V (int *ch, int *position);

   } /* F */

int V (int *ch, int *position)
   {
      /*
       *       V ------>[L]-------------->[M]--------->
       *            |        |         |        |
       *            |        --->(.)--->        |
       *            |                           |
       *            ------------>(x)------------>
       */

      int L (int *ch, int *position);
      int M (int *ch, int *position);

   } /* V */

int L (int *ch, int *position)
   {
      /*
       *        L ---------->(a)------------------>
       *             |                 |
       *             ------->(b)------->
       *             |                 |
       *             ------->(c)------->
       */

   } /* L */

int M (int *ch, int *position)
   {
      /*
       *        M ---------->(0)------------------>
       *             |                 |
       *             ------->(1)------->
       *                     . 
       *                     . 
       *                     . 
       *                     . 
       *             ------->(9)------->
       */

   } /* M */

int main ()
   {
      int ch;
      int position;

      position = 0;

      while ((ch = get_data (&position)) != EOF)
         {
            if ( S (&ch, &position) != ERROR )
                  printf ("--- OK ---\n");
               else
                  {
                      ch = print_error_data (ch, position);
                      if (ch == EOF)
                            return OK;
                  }
            position = 0;
         }

      return OK;

   } /* main */
