/* hw4 -- Solution to Insanity Game  Fall 2000 */

/*    $Author: ee368c13 $
 *      $Date: 2000/09/19 00:55:17 $
 *  $Revision: 1.4 $
 */

#include "hw4.h"

/* Global information */

#define NUMBER_OF_MOVES (36)

Move_Info G_Possible_Moves[NUMBER_OF_MOVES] =
{
  { 0,  1,  3},
  { 0,  2,  5},
  { 1,  3,  6},
  { 1,  4,  8},
  { 2,  4,  7},
  { 2,  5,  9},
  { 3,  4,  5},
  { 3,  1,  0},
  { 3,  6, 10},
  { 3,  7, 12},
  { 4,  7, 11},
  { 4,  8, 13},
  { 5,  2,  0},
  { 5,  4,  3},
  { 5,  8, 12},
  { 5,  9, 14},
  { 6,  3,  1},
  { 6,  7,  8},
  { 7,  4,  2},
  { 7,  8,  9},
  { 8,  4,  1},
  { 8,  7,  6},
  { 9,  5,  2},
  { 9,  8,  7},
  {10,  6,  3},
  {10, 11, 12},
  {11,  7,  4},
  {11, 12, 13},
  {12,  7,  3},
  {12,  8,  5},
  {12, 11, 10},
  {12, 13, 14},
  {13,  8,  4},
  {13, 12, 11},
  {14,  9,  5},
  {14, 13, 12}
};

int G_Number_Of_Trys = 0;

Boolean Try (int Move_Number)
{
  /*
   * Recursive backtacking for finding
   * a solution to the game of Insanity
   *
   *                    Insanity Game
   * 
   *             -------- Goal Peg 0 --------
   *
   *         ( )                        0
   *       (P) (P)                    1   2
   *     (P) (P) (P)                3   4   5
   *   (P) (P) (P) (P)            6   7   8   9
   * (P) (P) (P) (P) (P)       10  11  12  13  14
   *
   * Goal Board
   *
   *         (P)                        0
   *       ( ) ( )                    1   2
   *     ( ) ( ) ( )                3   4   5
   *   ( ) ( ) ( ) ( )            6   7   8   9
   * ( ) ( ) ( ) ( ) ( )       10  11  12  13  14
   *
   * Object:
   *    To transform the Inital Board to the
   *    Goal Board by jumping over pegs in
   *    vertical, horizontal, and diagonal
   *    directions and removing the jumped peg
   */ 

  Boolean Goal_Met = False;    
  Boolean Sucessful = False;
  int Move_Sequence = 0;
  int Local_From = 0;
  int Local_Over = 0;
  int Local_To = 0;
  int I = 0;

 do 
  {
    /*  Set up the next possible move  */
 
    G_Number_Of_Trys++;
    
    Local_From = G_Possible_Moves[Move_Sequence].From;
    Local_Over = G_Possible_Moves[Move_Sequence].Over;
    Local_To = G_Possible_Moves[Move_Sequence].To;
   
    /* Check for valid move */
   
    if (   (G_Board[Local_From] == Peg)  
        && (G_Board[Local_Over] == Peg)
        && (G_Board[Local_To] == Hole))
    {
      
      /*
       * Record the action taken on Game Board
       * and also on the Solution List.
       */
    
      G_Board[Local_From] = Hole;
      G_Board[Local_Over] = Hole;
      G_Board[Local_To] = Peg;
        
      G_Solution_List[Move_Number].From = Local_From;
      G_Solution_List[Move_Number].Over = Local_Over;
      G_Solution_List[Move_Number].To = Local_To;
       
      /* 
       * Check whether goal has been met
       * Even one instance of inequality will flag a False
       */
      
      Goal_Met = True;
      for (I=0; I < NUMBER_OF_HOLES; I++)
      {
        if (G_Board[I] != G_Goal_Board[I])
        {
          Goal_Met = False;
        }
      }

      /*
       * If Goal is met but the number of moves is not the
       * right number - MAX_MOVES, then flag False.
       */

      if (   (Goal_Met == True)
          && (Move_Number != MAX_MOVES))
      {   
        Sucessful = False;
        return (Sucessful);
      }
      else if (Goal_Met == False)
      {
        /*
         * If the goal has not been met.  Try again
         * by increasing the Move_Number.
         */
        
        Sucessful = Try (Move_Number + 1);
        if (Sucessful == False)
        {
          /* Return board to previous condition */
       
          G_Board[Local_From] = Peg;
          G_Board[Local_Over] = Peg;
          G_Board[Local_To] = Hole;
           
          /*   
           * Erase one step of solution in the list
           */
          
          G_Solution_List[Move_Number].From = Invalid;
          G_Solution_List[Move_Number].Over = Invalid;
          G_Solution_List[Move_Number].To = Invalid;
        
        }  
      }
      else
      {
        Sucessful = True;
      } 
    }

    Move_Sequence++;

  } while (   (Sucessful == False)
           && (Move_Sequence < NUMBER_OF_MOVES));
  
  return Sucessful;
} /* Try */

